//----------------------------------------------------------------------------------
// aviutl  GPUJX^tB^ GtFNgt@CǂݎpNX
// Copyright (c) 2007  N099
//----------------------------------------------------------------------------------
#include <windows.h>

#include <new>
#include <shlwapi.h>
#include <strsafe.h>

#include <d3d9.h>
#include <d3dx9.h>
#include <d3dx9math.h>
#include <dxerr.h>

#include "effect_reader.h"

//ǂݍލől
static const int TRACK_MAX = 32;
static const int CHECK_MAX = 32;

//Effectt@CFILTER_DLL\̂쐬邽߂̃NX

EffectReader::EffectReader() : 
	m_pCompiler(NULL), m_pCompiledEffect(NULL),
	m_ppTrackName(NULL), m_pTrackDefaut(NULL),
	m_pTrackMax(NULL), m_pTrackMin(NULL),
	m_ppCheckName(NULL), m_pCheckDefaut(NULL),
	m_Name(NULL), m_NameT(NULL), m_ExInfo(NULL),
	m_hD3dxdll(0), m_pCreateEffectComp(NULL),
	m_pCreateEffect(NULL), m_pCreateBuffer(NULL)
{
}

EffectReader::~EffectReader()
{
	//\[X̊J
	SAFE_RELEASE(m_pCompiledEffect);
	SAFE_RELEASE(m_pCompiler);

	if(m_ppTrackName) free(m_ppTrackName);
	SAFE_DELETE_ARRAY(m_pTrackDefaut);
	SAFE_DELETE_ARRAY(m_pTrackMax);
	SAFE_DELETE_ARRAY(m_pTrackMin);
	m_Track.clear();

	if(m_ppCheckName) free(m_ppCheckName);
	SAFE_DELETE_ARRAY(m_pCheckDefaut);
	m_Check.clear();

	SAFE_DELETE(m_Name);
	SAFE_DELETE(m_NameT);
	SAFE_DELETE(m_ExInfo);

	if(m_hD3dxdll){
		FreeLibrary(m_hD3dxdll);
	}
}

//NX̏
bool EffectReader::Init(HMODULE hDll)
{
	//KvȊ֐d3dx_dllo
	if(m_hD3dxdll){
		FreeLibrary(m_hD3dxdll);
		m_hD3dxdll = 0;
		m_pCreateEffectComp = NULL;
		m_pCreateEffect = NULL;
		m_pCreateBuffer = NULL;
	}

	//pX𒲍
	const int path_max = 32768;
	TCHAR *path = new(std::nothrow) TCHAR[path_max];
	if(path == NULL){
		return false;
	}

	//~ōŏɑ݂郉Cu𗘗p
	for(int j=0; j<2; ++j){
		size_t len;

		//{̂Ɠʒuɂ̂D
		if(j==0){
			len = GetModuleFileName(hDll, path, path_max - 1);
			PathRemoveFileSpec(path);
			StringCchLength(path, path_max, &len);
		}else{
			len = GetSystemDirectory(path, path_max - 1);
		}

		//pX擾G[
		if(len == 0){
			continue;
		}
		
		//~Ńt@CT[`
		for(int i=D3DXLIB_VER_MAX; i>=D3DXLIB_VER_MIN; --i){
#ifdef _DEBUG
			StringCchPrintf(path + len, path_max - len, TEXT("\\d3dx9d_%02d.dll"), i);
#else
			StringCchPrintf(path + len, path_max - len, TEXT("\\d3dx9_%02d.dll"), i);
#endif
			//t@C݃`FbN
			if(INVALID_FILE_ATTRIBUTES == GetFileAttributes(path)){
				continue;
			}

			//Cu[h
			m_hD3dxdll = LoadLibraryEx(path, NULL, LOAD_WITH_ALTERED_SEARCH_PATH);
			if(m_hD3dxdll){
				//[h
				j = 2;
				break;
			}
		}
	}

	delete[] path;

	//[hłꍇA֐Gg擾
	if(m_hD3dxdll == 0){
		ShowMessageBox(__FILE__, (DWORD)__LINE__, E_FAIL,
			TEXT("D3DXCu[hł܂B")
			TEXT("ŐVDirectXGh[U[^C𓱓ĂB"));
		return false;
	}
#ifdef UNICODE
	m_pCreateEffectComp = reinterpret_cast<CREATEEFFECTCOMP>
		(GetProcAddress(m_hD3dxdll, "D3DXCreateEffectCompilerFromFileW"));
#else
	m_pCreateEffectComp = reinterpret_cast<CREATEEFFECTCOMP>
		(GetProcAddress(m_hD3dxdll, "D3DXCreateEffectCompilerFromFileA"));
#endif
	m_pCreateEffect = reinterpret_cast<CREATEEFFECT>
		(GetProcAddress(m_hD3dxdll, "D3DXCreateEffect"));
	m_pCreateBuffer = reinterpret_cast<CREATEBUFFER>
		(GetProcAddress(m_hD3dxdll, "D3DXCreateBuffer"));

	//擾ł`FbN
	if(m_pCreateEffectComp && m_pCreateEffect && m_pCreateBuffer){
		return true;
	}else{
		FreeLibrary(m_hD3dxdll);
		m_hD3dxdll = 0;
		m_pCreateEffectComp = NULL;
		m_pCreateEffect = NULL;
		m_pCreateBuffer = NULL;
		return false;
	}
}

//GtFNgt@CǂݍŃRpCăf[^ǂݎ
bool EffectReader::OpenEffectFile(const TCHAR *path)
{
	IDirect3D9 *pD3D = NULL;
	IDirect3DDevice9 *pd3dDevice = NULL;
	ID3DXBaseEffect *pBe = NULL;

	//JĂ
	SAFE_RELEASE(m_pCompiler);
	SAFE_RELEASE(m_pCompiledEffect);

	//t@C[hăGtFNgRpC쐬
	if(FAILED(LoadEffect(path))){
		return false;
	}

	//bin or text ŏύX
	if(m_pCompiledEffect == NULL){
		//GtFNgt@CRpC
		if(FAILED(CompileEffect())){
			return false;
		}
		pBe = m_pCompiler;
		pBe->AddRef();
	}else{
		//UfoCXƃGtFNg쐬
		pD3D = Direct3DCreate9(D3D_SDK_VERSION);
		if(NULL == pD3D) {
			SAFE_RELEASE(m_pCompiledEffect);
			ShowMessageBox(__FILE__, (DWORD)__LINE__, E_FAIL, TEXT("D3D(pre)̍쐬Ɏs܂"));
			return false;
		}

		//create device
		D3DPRESENT_PARAMETERS d3dpp; 
		ZeroMemory(&d3dpp, sizeof(d3dpp));
		d3dpp.Windowed = TRUE;
		d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
		d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;

		HRESULT hr = pD3D->CreateDevice(
			D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, GetDesktopWindow(),
			D3DCREATE_SOFTWARE_VERTEXPROCESSING|D3DCREATE_NOWINDOWCHANGES|D3DCREATE_MULTITHREADED, 
			&d3dpp, &pd3dDevice );
		if(FAILED(hr)){
			ShowMessageBox(__FILE__, (DWORD)__LINE__, hr, TEXT("D3D(pre)foCX̍쐬Ɏs܂"));
			SAFE_RELEASE(pD3D);
			return false;
		}

		//GtFNg̍쐬
		ID3DXEffect *pEf = NULL;
		hr = CreateEffect(pd3dDevice, D3DXFX_NOT_CLONEABLE|D3DXFX_LARGEADDRESSAWARE, &pEf);
		if(FAILED(hr)){
			ShowMessageBox(__FILE__, (DWORD)__LINE__, hr, TEXT("GtFNg(pre)̍쐬Ɏs܂"));
		}else{
			pBe = pEf;
		}
	}

	//tB^̓ǂݎ
	bool ret = false;
	if(pBe != NULL){
		ret = LoadFilterInfo(pBe);
		if(ret) ret = LoadTrackInfo(pBe);
		if(ret) ret = LoadCheckInfo(pBe);
	}

	//release
	SAFE_RELEASE(pBe);
	SAFE_RELEASE(pd3dDevice);
	SAFE_RELEASE(pD3D);

	return ret;
}

//foCXɌѕtꂽGtFNg쐬
HRESULT EffectReader::
CreateEffect(LPDIRECT3DDEVICE9 pDevice, DWORD Flags, LPD3DXEFFECT *ppEffect)
{
	HRESULT hr;

	if(!m_pCompiledEffect){
		//GtFNgRpCĂȂ
		return E_NOINTERFACE;
	}else if(!m_pCreateEffect){
		//GtFNg쐬֐擾łĂȂ
		return E_NOINTERFACE;
	}

	//GtFNg̍쐬
	hr = m_pCreateEffect(pDevice, m_pCompiledEffect->GetBufferPointer(),
		m_pCompiledEffect->GetBufferSize(), NULL, NULL, Flags, NULL, ppEffect, NULL);

	return hr;
}

//---------------------------------------------------------------------
// internal functions
//---------------------------------------------------------------------

//tB^̓ǂݎ
bool EffectReader::LoadFilterInfo(ID3DXBaseEffect *pEffect)
{
	if(!pEffect){
		return false;
	}

	D3DXHANDLE hVer = pEffect->GetParameterByName(NULL, "FilterVersion");
	if(hVer){
		D3DXHANDLE hName,hExInf;
		LPCSTR str;
		size_t len;

		hName = pEffect->GetAnnotationByName(hVer, "name");
		hExInf = pEffect->GetAnnotationByName(hVer, "ex_info");

		//o[Wԍ
		pEffect->GetIntArray(hVer, m_Version, ARRAYSIZE(m_Version));

		//OȂ
		if(hName){
			SAFE_DELETE(m_Name);
			SAFE_DELETE(m_NameT);
			if(S_OK == pEffect->GetString(hName, &str)){
				StringCchLengthA(str, STRSAFE_MAX_CCH, &len);
				m_Name = new(std::nothrow) CHAR[len + 1];
				if(m_Name){
					 StringCchCopyA(m_Name, len + 1, str);
				}	
#ifdef UNICODE
				mbstowcs_s(&len, NULL, 0, str, 0);
				m_NameT = new(std::nothrow) TCHAR[len]; //includes L'\0'
				if(m_NameT){
					 mbstowcs_s(&len, m_NameT, len, str, len - 1);
				}	
#else
				m_NameT = new(std::nothrow) TCHAR[len + 1];
				if(m_NameT){
					 StringCchCopyA(m_NameT, len + 1, str);
				}
#endif
			}
		}
		if(hExInf){
			SAFE_DELETE(m_ExInfo);
			if(S_OK == pEffect->GetString(hExInf, &str)){
				StringCchLengthA(str, STRSAFE_MAX_CCH, &len);
				m_ExInfo = new(std::nothrow) CHAR[len + 1 + 32];
				if(m_ExInfo){
					 StringCchCopyA(m_ExInfo, len + 1, str);
					 StringCchPrintfA(&m_ExInfo[len], 1 + 32,
						 ", v%d.%d", m_Version[0], m_Version[1]);
				}
			}
		}
	}

	return true;
}

//gbNo[ݒ̓ǂݎ
bool EffectReader::LoadTrackInfo(ID3DXBaseEffect *pEffect)
{
	if(!pEffect){
		return false;
	}

	//JEg
	size_t nlen = TRACK_MAX * sizeof(CHAR*);
	m_Track.clear();

	//1st pass
	for(int i=0; i<TRACK_MAX; ++i){
		CHAR var_name[32];
		StringCchPrintfA(var_name, ARRAYSIZE(var_name), "Track%d", i);

		D3DXHANDLE hTr = pEffect->GetParameterByName(NULL, var_name);

		if(hTr == NULL){
			//T[`I
			break;
		}

		//p[^ǂݎ
		D3DXHANDLE hName,hDef,hMin,hMax,hUse;
		hName = pEffect->GetAnnotationByName(hTr, "name");
		hDef  = pEffect->GetAnnotationByName(hTr, "def");
		hMax  = pEffect->GetAnnotationByName(hTr, "max");
		hMin  = pEffect->GetAnnotationByName(hTr, "min");
		hUse  = pEffect->GetAnnotationByName(hTr, "usage");

		//p[^ۑ
		TrackInfo inf = { var_name, 0, 0, 1, "" };

		if(hName){
			LPCSTR str;
			if(S_OK == pEffect->GetString(hName, &str)){
				inf.name = str;
			}
		}
		nlen += inf.name.length() + 1;

		if(hDef) pEffect->GetInt(hDef, &inf.def);
		if(hMax) pEffect->GetInt(hMax, &inf.max);
		if(hMin) pEffect->GetInt(hMin, &inf.min);
		if(hUse){
			LPCSTR str;
			if(S_OK == pEffect->GetString(hUse, &str)){
				inf.usage = str;
			}
		}

		//ǉ
		m_Track.push_back(inf);
	}

	//2nd pass
	if(m_Track.size() > 0){
		//̈m
		free(m_ppTrackName);
		m_ppTrackName = NULL;
		SAFE_DELETE_ARRAY(m_pTrackDefaut);
		SAFE_DELETE_ARRAY(m_pTrackMax);
		SAFE_DELETE_ARRAY(m_pTrackMin);

		m_ppTrackName = (CHAR**)malloc(nlen);
		if(m_ppTrackName == NULL) return false;
		
		m_pTrackDefaut = new(std::nothrow) int[m_Track.size()];
		if(m_pTrackDefaut == NULL) return false;

		m_pTrackMax = new(std::nothrow) int[m_Track.size()];
		if(m_pTrackMax == NULL) return false;

		m_pTrackMin = new(std::nothrow) int[m_Track.size()];
		if(m_pTrackMin == NULL) return false;

		//f[^i[
		CHAR *p_name = reinterpret_cast<CHAR*>(&m_ppTrackName[TRACK_MAX]);
		for(unsigned int i=0; i<m_Track.size(); ++i){
			m_ppTrackName[i]  = p_name;
			m_pTrackDefaut[i] = m_Track[i].def;
			m_pTrackMax[i]    = m_Track[i].max;
			m_pTrackMin[i]    = m_Track[i].min;
			
			//ݒ薼̃Rs[
			size_t len = m_Track[i].name.length() + 1;
			StringCchCopyA(p_name, len, m_Track[i].name.c_str());
			p_name += len;
		}
	}

	return true;
}

//`FbN{bNX̓ǂݎ
bool EffectReader::LoadCheckInfo(ID3DXBaseEffect *pEffect)
{
	if(!pEffect){
		return false;
	}

	//JEg
	size_t nlen = CHECK_MAX * sizeof(CHAR*);
	m_Check.clear();

	//1st pass
	for(int i=0; i<CHECK_MAX; ++i){
		CHAR var_name[32];
		StringCchPrintfA(var_name, ARRAYSIZE(var_name), "Check%d", i);

		D3DXHANDLE hChk = pEffect->GetParameterByName(NULL, var_name);

		if(hChk == NULL){
			//T[`I
			break;
		}

		//p[^ǂݎ
		D3DXHANDLE hName,hDef,hUse;
		hName = pEffect->GetAnnotationByName(hChk, "name");
		hDef  = pEffect->GetAnnotationByName(hChk, "def");
		hUse  = pEffect->GetAnnotationByName(hChk, "usage");

		//p[^ۑ
		CheckInfo inf = { var_name, 0, "" };

		if(hName){
			LPCSTR str;
			if(S_OK == pEffect->GetString(hName, &str)){
				inf.name = str;
			}
		}
		nlen += inf.name.length() + 1;

		if(hDef) pEffect->GetBool(hDef, (BOOL*)&inf.def);
		if(hUse){
			LPCSTR str;
			if(S_OK == pEffect->GetString(hUse, &str)){
				inf.usage = str;
			}
		}

		//ǉ
		m_Check.push_back(inf);
	}

	//2nd pass
	if(m_Check.size() > 0){
		//̈m
		free(m_ppCheckName);
		m_ppCheckName = NULL;
		SAFE_DELETE_ARRAY(m_pCheckDefaut);

		m_ppCheckName = (CHAR**)malloc(nlen);
		if(m_ppCheckName == NULL) return false;
		
		m_pCheckDefaut = new(std::nothrow) int[m_Check.size()];
		if(m_pCheckDefaut == NULL) return false;

		//f[^i[
		CHAR *p_name = reinterpret_cast<CHAR*>(&m_ppCheckName[CHECK_MAX]);
		for(unsigned int i=0; i<m_Check.size(); ++i){
			m_ppCheckName[i]  = p_name;
			m_pCheckDefaut[i] = m_Check[i].def;
			
			//ݒ薼̃Rs[
			size_t len = m_Check[i].name.length() + 1;
			StringCchCopyA(p_name, len, m_Check[i].name.c_str());
			p_name += len;
		}
	}

	return true;
}

//GtFNgt@Cǂݍ
HRESULT EffectReader::LoadEffect(const TCHAR *path)
{
	HRESULT hr;
	TCHAR fx_path[MAX_PATH];
	
	//oCiGtFNgt@Cp
	StringCchCopy(fx_path, MAX_PATH, path);
	PathRenameExtension(fx_path, TEXT(".fxo"));
	if(SUCCEEDED(LoadCompiledEffect(fx_path))){
		//RpCς݃GtFNg[h
		return S_FALSE;
	}

	if(!m_pCreateEffectComp){
		//GtFNgRpC쐬֐擾łĂȂ
		return E_NOINTERFACE;
	}

	//vOCo[W̎擾
	DWORD file_ver  = ReadPulginVersion(path);
	CHAR ver_string[16] = "0x00000000";
	if(file_ver == 0){
		//t@C̃o[W擾s
		return E_FAIL;
	}else{
		StringCchPrintfA(ver_string, 16, "0x%08x", file_ver);
	}

	//GtFNgt@CɃo[Wԍ
	D3DXMACRO mac[2] = { { GPU_CUSTOM_VER_DECL, ver_string }, { NULL, NULL } };

	//GtFNgt@C𐶐
	PathRenameExtension(fx_path, TEXT(".fx"));

	//GtFNgRpC̍쐬
	ID3DXBuffer *pErrBuf = NULL;
	SAFE_RELEASE(m_pCompiler);
	hr = m_pCreateEffectComp(fx_path, mac, NULL, 0, &m_pCompiler, &pErrBuf);
	if(D3D_OK != hr){
		if(pErrBuf){
			//RpCG[\
			char *msg = (char*)pErrBuf->GetBufferPointer();
#ifdef UNICODE
			if(msg){
				size_t count = pErrBuf->GetBufferSize();
				WCHAR *str = new(std::nothrow) WCHAR[count];
				if(str){
					size_t ret;
					mbstowcs_s(&ret, str, count, msg, count);
					str[count -1] = L'\0';
					ShowMessageBox(__FILE__, (DWORD)__LINE__, hr, str);
					delete[] str;
				}
			}
#else
			if(msg){
				ShowMessageBox(__FILE__, (DWORD)__LINE__, hr, msg);
			}
#endif
			pErrBuf->Release();
		}
	}

	return hr;
}

//GtFNgt@C̃RpC
HRESULT EffectReader::CompileEffect(DWORD flags)
{
	HRESULT hr;

	if(!m_pCompiler){
		//GtFNgRpC쐬ĂȂ
		return E_NOINTERFACE;
	}

	//RpC
	ID3DXBuffer *pErrBuf = NULL;
	SAFE_RELEASE(m_pCompiledEffect);
	hr = m_pCompiler->CompileEffect(flags, &m_pCompiledEffect, &pErrBuf);
	if(D3D_OK != hr){
		if(pErrBuf){
			//RpCG[\
			char *msg = (char*)pErrBuf->GetBufferPointer();
#ifdef UNICODE
			if(msg){
				size_t count = pErrBuf->GetBufferSize();
				WCHAR *str = new(std::nothrow) WCHAR[count];
				if(str){
					size_t ret;
					mbstowcs_s(&ret, str, count, msg, count);
					str[count -1] = L'\0';
					ShowMessageBox(__FILE__, (DWORD)__LINE__, hr, str);
					delete[] str;
				}
			}
#else
			if(msg){
				ShowMessageBox(__FILE__, (DWORD)__LINE__, hr, msg);
			}
#endif
			pErrBuf->Release();
		}
	}

	return hr;
}

//RpCς݃GtFNg[h
HRESULT EffectReader::LoadCompiledEffect(const TCHAR *path)
{
	HRESULT hr;
	HANDLE hFile;
	DWORD size;

	if(!m_pCreateBuffer){
		//obt@쐬֐擾łĂȂ
		return E_NOINTERFACE;
	}

	hFile = CreateFile(path, GENERIC_READ,
		FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == NULL){
		return E_FAIL;
	}

	size = GetFileSize(hFile, NULL);
	if(size == INVALID_FILE_SIZE){
		CloseHandle(hFile);
		return E_UNEXPECTED;
	}

	//obt@쐬ēǂݎ
	SAFE_RELEASE(m_pCompiledEffect);
	hr = m_pCreateBuffer(size, &m_pCompiledEffect);
	if(SUCCEEDED(hr)){
		DWORD rdsize = 0;
		BOOL ret = ReadFile(hFile, m_pCompiledEffect->GetBufferPointer(), size, &rdsize, NULL);
		if(!ret || (rdsize != size)){
			hr = E_UNEXPECTED;
			SAFE_RELEASE(m_pCompiledEffect);
		}
	}

	CloseHandle(hFile);
	return hr;
}

//vOC{̂̃o[W擾
DWORD EffectReader::ReadPulginVersion(const TCHAR *path)
{
	DWORD ret,len = 0;

	len = GetFileVersionInfoSize(path, &ret);
	if(len == 0){
		return 0;
	}

	VOID *data = malloc(len);
	if(data == NULL){
		return 0;
	}

	if(0 == GetFileVersionInfo(path, 0, len, data)){
		//擾s
		free(data);
		return 0;
	}

	//t@Co[W̓ǂݎ
	VS_FIXEDFILEINFO *pinfo = NULL;
	UINT size = 0;
	if(0 == VerQueryValue(data, TEXT("\\"), (void**)&pinfo, &size)){
		//擾s
		free(data);
		return 0;
	}
	ret = pinfo->dwFileVersionMS;
	free(data);

	return ret;
}

//G[̕\
HRESULT EffectReader::ShowMessageBox(const char *file, DWORD line, HRESULT hr, const TCHAR *msg)
{
#ifdef _DEBUG
	return DXTrace(file, line, hr, msg, TRUE);
#else
	MessageBox(NULL, msg, TEXT("GtFNgt@C̃G["), MB_ICONERROR|MB_SYSTEMMODAL);
	return S_OK;
#endif
}

