//----------------------------------------------------------------------------------
// aviutl  GPUJX^tB^ GtFNgt@CǂݎpNX
// Copyright (c) 2007  N099
//----------------------------------------------------------------------------------
#pragma once

#include <vector>
#include <string>

#define GPU_CUSTOM_VER_DECL "GPU_CUSTOM_VER"

//D3DXCui[hd3dxdll̃o[Wwj
const int D3DXLIB_VER_MIN = 38;
const int D3DXLIB_VER_MAX = 42;

//GtFNgǂݎp֐
typedef HRESULT (WINAPI * CREATEEFFECTCOMP)(LPCTSTR, CONST D3DXMACRO*,
											LPD3DXINCLUDE, DWORD Flags,
											LPD3DXEFFECTCOMPILER*, LPD3DXBUFFER*);

typedef HRESULT (WINAPI * CREATEEFFECT)(LPDIRECT3DDEVICE9, LPCVOID, UINT,
										CONST D3DXMACRO*, LPD3DXINCLUDE, DWORD,
										LPD3DXEFFECTPOOL, LPD3DXEFFECT*, LPD3DXBUFFER*);

typedef HRESULT (WINAPI * CREATEBUFFER)(DWORD, LPD3DXBUFFER*);

//gbNE`FbNݒ
struct TrackInfo {
	std::string name;
	int def;
	int max;
	int min;
	std::string usage;
};

struct CheckInfo {
	std::string name;
	int def;
	std::string usage;
};

//Effectt@CFILTER_DLL\̂쐬邽߂̃NX
class EffectReader
{
private:
	ID3DXEffectCompiler *m_pCompiler;
	ID3DXBuffer *m_pCompiledEffect;

	std::vector<TrackInfo> m_Track;
	CHAR **m_ppTrackName;
	int *m_pTrackDefaut;
	int *m_pTrackMax;
	int *m_pTrackMin;

	std::vector<CheckInfo> m_Check;
	CHAR **m_ppCheckName;
	int *m_pCheckDefaut;

	int m_Version[4];
	CHAR *m_Name;
	TCHAR *m_NameT;
	CHAR *m_ExInfo;

	//GtFNgǂݎp(from DLL)
	HMODULE m_hD3dxdll;
	CREATEEFFECTCOMP m_pCreateEffectComp;
	CREATEEFFECT m_pCreateEffect;
	CREATEBUFFER m_pCreateBuffer;

public:
	EffectReader();
	~EffectReader();

	bool Init(HMODULE hDll);
	bool OpenEffectFile(const TCHAR *path);

	//gbNRg[
	int GetTrackNum(void) const { return (int)m_Track.size(); }
	CHAR **GetTrackName(void) const { return m_ppTrackName; }
	int *GetTrackDefault(void) const { return m_pTrackDefaut; }
	int *GetTrackMax(void) const { return m_pTrackMax; }
	int *GetTrackMin(void) const { return m_pTrackMin; }
	const std::vector<TrackInfo>& GetTrackInfo(void) const { return m_Track; }

	//`FbN{bNX
	int GetCheckNum(void) const { return (int)m_Check.size(); }
	CHAR **GetCheckName(void) const { return m_ppCheckName; }
	int *GetCheckDefault(void) const { return m_pCheckDefaut; }
	const std::vector<CheckInfo>& GetCheckInfo(void) const { return m_Check; }

	//tB^Ȃ
	CHAR *GetFilterName(void) const { return m_Name; }
	const TCHAR *GetFilterNameT(void) const { return m_NameT; }
	CHAR *GetExInfo(void) const { return m_ExInfo; }

	//foCXɌѕtꂽGtFNg
	HRESULT CreateEffect(LPDIRECT3DDEVICE9 pDevice, DWORD Flags, LPD3DXEFFECT *ppEffect);

private:
	//gp
	bool LoadFilterInfo(ID3DXBaseEffect *pEffect);
	bool LoadTrackInfo(ID3DXBaseEffect *pEffect);
	bool LoadCheckInfo(ID3DXBaseEffect *pEffect);
	HRESULT LoadEffect(const TCHAR *path);
	HRESULT LoadCompiledEffect(const TCHAR *path);
	HRESULT CompileEffect(DWORD flags = 0);
	DWORD ReadPulginVersion(const TCHAR *path);
	HRESULT ShowMessageBox(const char *file, DWORD line, HRESULT hr, const TCHAR *msg);
};

//---------------------------------------------------------------------
// macro
//---------------------------------------------------------------------
#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#endif    
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#endif    
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }
#endif
