//----------------------------------------------------------------------------------
// aviutl GPUJX^tB^
// Copyright (c) 2007-2010  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <xmmintrin.h>
#include <new>

#include <d3d9.h>
#include <d3dx9.h>
#include <dxerr.h>

#include "filter.h"
#include "effect_reader.h"
#include "util.h"
#include "thrproc.h"
#include "gpufilter.h"

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
EffectReader g_EffectReader;
GpuFilter *g_pGpuFilter = NULL;
bool g_chg_param = true;
bool g_need_realloc = true;
HMODULE g_hdll = NULL;

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
// UNICODErh邽ߏςɂȂĂ܂iDXTrace()Ȃ߁j
FILTER_DLL g_filter = {
	FILTER_FLAG_EX_INFORMATION | FILTER_FLAG_NO_INIT_DATA, 0, 0,
	(TCHAR*)"GPUJX^(G[)",
	0, NULL, NULL, NULL, NULL, //track
	0, NULL, NULL,             //check
	func_proc,
	func_init,
	func_exit,
	func_update,
	func_WndProc,
	NULL, NULL, NULL, 0,
	(TCHAR*)"gpu_custom by N099, ver1.0a",
	NULL,  NULL,
};

//---------------------------------------------------------------------
//     DLL̃Gg|Cg
//---------------------------------------------------------------------
BOOL APIENTRY DllMain(HANDLE hModule, DWORD reason, LPVOID)
{
	if(reason == DLL_PROCESS_ATTACH){
		//ŃGtFNgt@C𓾂邽ߎg̃nhۑ
		g_hdll = static_cast<HMODULE>(hModule);
	}

	return TRUE;
}

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	//GtFNgt@Cǂݍ
	if(false == g_EffectReader.Init(g_hdll)){
		return &g_filter;
	}

	//W[GtFNgt@C𓾂
	const int path_max = 32768;
	TCHAR *name = new(std::nothrow) TCHAR[path_max];
	if(NULL == name){
		return &g_filter;
	}

	if(GetModuleFileName(g_hdll, name, path_max - 1)){
		name[path_max - 1] = TEXT('\0'); //Ŝ
	}else{
		static const TCHAR def[] = TEXT("gpu_custom.auf");
		CopyMemory(name, def, sizeof(def));
	}

	//GtFNgt@Cǂݍ
	if(true == g_EffectReader.OpenEffectFile(name)){
		//ǂݍ񂾃f[^ɂč\̂
		TCHAR *str;

		str = (TCHAR*)g_EffectReader.GetFilterName();
		if(str) g_filter.name = str;

		str = (TCHAR*)g_EffectReader.GetExInfo();
		if(str) g_filter.information = str;

		g_filter.track_n       = g_EffectReader.GetTrackNum();
		g_filter.track_name    = (TCHAR**)g_EffectReader.GetTrackName();
		g_filter.track_default = g_EffectReader.GetTrackDefault();
		g_filter.track_s       = g_EffectReader.GetTrackMin();
		g_filter.track_e       = g_EffectReader.GetTrackMax();

		g_filter.check_n       = g_EffectReader.GetCheckNum();
		g_filter.check_name    = (TCHAR**)g_EffectReader.GetCheckName();
		g_filter.check_default = g_EffectReader.GetCheckDefault();
	}

	delete[] name;

	return &g_filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
	//GpuFilter
	g_pGpuFilter = new(std::nothrow) GpuFilter(g_EffectReader);
	if(NULL == g_pGpuFilter){
		return FALSE;
	}

	//foCXIp
	int dev = fp->exfunc->ini_load_int(fp, "dev", 0);

	//CPU/GPU
	bool pp = (fp->exfunc->ini_load_int(fp, "disable_pp", 0) == 0);

	//FfoCX̃eXgs
	if(!g_pGpuFilter->Init(fp, dev, pp)){
		SAFE_DELETE(g_pGpuFilter);
		return FALSE;
	}

	return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *)
{
	SAFE_DELETE(g_pGpuFilter);

	return TRUE;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	if(!g_pGpuFilter) return FALSE;

	//Qƃt[it[܂ށj
	const int n_ref = g_pGpuFilter->GetRefFrameCount();

	//t[LbV̊m
	if(!fp->exfunc->set_ycp_filtering_cache_size(
		fp, fpip->max_w, fpip->max_h, n_ref+1, 0))
	{
		return FALSE;
	}

	//݂̃t[cacheoRŎ擾
	PIXEL_YC *pyc = fp->exfunc->get_ycp_filtering_cache_ex(
		fp, fpip->editp, fpip->frame, &fpip->w, &fpip->h);
	if(pyc == NULL){
		return FALSE;
	}

	//TCYύX̃`FbN
	if(fpip->w != g_pGpuFilter->GetWidth() || fpip->h != g_pGpuFilter->GetHeight()){
		g_need_realloc = true;
	}

	//foCX̏Ԃ`FbN
	if(!g_pGpuFilter->TestDeviceState(&g_need_realloc)) return FALSE;

	//p[^ύXꂽꍇ
	if(g_need_realloc){
		g_pGpuFilter->ReleaseResources();
		if(!g_pGpuFilter->AllocResources(fpip->w, fpip->h, fpip->max_w)){
			return FALSE;
		}

		g_pGpuFilter->SetParams(fp->track, fp->check);
		g_need_realloc = false;
		g_chg_param = false;
	}else if(g_chg_param){
		g_pGpuFilter->SetParams(fp->track, fp->check);
		g_chg_param = false;
	}

	//t[ԍ̃Zbg
	if(!g_pGpuFilter->SetFrame(fpip->frame, fpip->frame_n)) return FALSE;

	//Kvȃt[擾ēn
	for(int i=0; i<n_ref; ++i){
		int n = g_pGpuFilter->GetRefFrame(i);

		if(!g_pGpuFilter->IsFrameCached(n)){
			pyc = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, n, NULL, NULL);
			if(pyc == NULL) return FALSE;

			//f[^]
			if(!g_pGpuFilter->PutImage(pyc, n, fp->exfunc->exec_multi_thread_func)){
				return FALSE;
			}
		}
	}

	//GPUŏ
	int next_frame = -1;
	if(g_pGpuFilter->ProcImage(&next_frame)){
		//񏈗̂ߐǂ݂s
		if(next_frame >= 0){
			pyc = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, next_frame, NULL, NULL);
			if(pyc == NULL) return FALSE;
		}
	}else{
		return FALSE;
	}

	//o̓f[^o
	if(!g_pGpuFilter->GetImage(fpip->ycp_edit, fp->exfunc->exec_multi_thread_func)){
		return FALSE;
	}

	return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *, int)
{
	g_chg_param = true;
	return TRUE;
}

//---------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc(HWND, UINT msg, WPARAM, LPARAM, void *, FILTER *fp)
{
	switch(msg){
#if 0 //TODO:LbṼNA
	case WM_FILTER_UPDATE: //etB^ݒҏWeύXꂽɑ܂
		if(g_pGpuFilter && fp->exfunc->is_filter_active(fp)){
			g_pGpuFilter->ClearRefFrames();
		}
		break;
#else
	case WM_MBUTTONDOWN:
		if(g_pGpuFilter && fp->exfunc->is_filter_active(fp)){
			g_pGpuFilter->ClearRefFrames();
			return TRUE;
		}
		break;
#endif
	case WM_FILTER_CHANGE_ACTIVE: //tB^̗L/ύXꂽɑ܂
		if(g_pGpuFilter && !fp->exfunc->is_filter_active(fp)){
			//L->؂ւ̂݃\[XJ
			g_pGpuFilter->ReleaseResources();
			g_need_realloc = true;
		}
		break;
	case WM_FILTER_FILE_OPEN: //ҏWt@CI[vꂽɑ܂
		if(g_pGpuFilter){
			//t@CJȂƂɓt[XV邽
			g_pGpuFilter->ReleaseResources();
			g_need_realloc = true;
		}
		break;
	default:
		break;
	}

	return FALSE;
}

